import {HttpMethod, Route, StatusCodes, Request, Response} from 'org.crazydoctor.expressts';
import { Sources } from '../sources/Sources';
import ServerApp from '..';
import { ISession } from '../session/ISession';

class GetIndex extends Route {
	protected action = (req: Request, res: Response): any => {
		const session = req.session as ISession;

		if(ServerApp.SourcesUpdating) {
			res.status(StatusCodes.ACCEPTED).render('sources-update');
			return;
		}

		res.status(StatusCodes.OK).render('index', { isAdmin: session.isAdmin || false, isEditor: session.isEditor || false, Login: session.login || null, template: 'index', title: 'Doczilla JS Docs', lastUpdateTime: Sources.time().getTime(), ClassList: Sources.get(), RepoNames: Sources.getRepoNames() });
	};

	protected method = HttpMethod.GET;
	protected order = 0;
	protected route = '/';
}

export default GetIndex;